## ros-r2b2-class-loader 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(class_loader)

if(NOT WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wextra")
endif()

set(CLASS_LOADER_IGNORE_AMENT FALSE CACHE BOOL
  "Do not use ament when building this package.")
if(NOT CLASS_LOADER_IGNORE_AMENT)
  find_package(ament_cmake)
endif()

find_package(console_bridge REQUIRED)
find_package(poco_vendor REQUIRED)  # Provides FindPoco.cmake and Poco on platforms without it.
find_package(Poco REQUIRED COMPONENTS Foundation)
link_directories(${Poco_LIBRARY_DIR})

if(ament_cmake_FOUND)
  ament_export_dependencies(console_bridge)
  ament_export_include_directories(include)
  ament_export_libraries(${PROJECT_NAME})
endif()

set(${PROJECT_NAME}_SRCS
  src/class_loader.cpp
  src/class_loader_core.cpp
  src/meta_object.cpp
  src/multi_library_class_loader.cpp
)
add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_SRCS})
target_include_directories(${PROJECT_NAME}
  PUBLIC include ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} ${console_bridge_LIBRARIES} ${Poco_LIBRARIES})
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME} PRIVATE "CLASS_LOADER_BUILDING_DLL")
endif()

if(AMENT_ENABLE_TESTING)
  add_subdirectory(test)
endif()

if(ament_cmake_FOUND)
  ament_package(
    CONFIG_EXTRAS "class_loader-extras.cmake"
  )
else()
  set(TARGET_NAME ${PROJECT_NAME})
  set(PKGCONFIG_LIBS
    ${console_bridge_LIBRARIES}
    ${Poco_LIBRARIES}
  )

  # Prepare and install necessary files to support finding of the library
  # using pkg-config
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/src/${PROJECT_NAME}.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    @ONLY)

  install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc" DESTINATION lib/pkgconfig)
endif()

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME})

install(DIRECTORY include/${PROJECT_NAME}
  DESTINATION include)

=== .travis/Makefile ===
all: class_loader

UNAME := $(shell uname -s)

install_deps:
ifeq ($(UNAME),Darwin)
	brew update
	brew outdated python3 || brew upgrade python3 || brew install python3
	brew outdated poco || brew upgrade poco || brew install poco
	sudo -H python3 -m pip install -U empy
else
	sudo sh -c 'echo "deb http://packages.ros.org/ros/ubuntu trusty main" > /etc/apt/sources.list.d/ros-latest.list'
	wget http://packages.ros.org/ros.key -O - | sudo apt-key add -
	sudo apt-get update -qq
	sudo apt-get install cmake python3 python3-pip python3-empy python3-setuptools wget libpoco-dev
endif
	python3 --version

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)

include("../cmake/class_loader_hide_library_symbols.cmake")

add_library(${PROJECT_NAME}_TestPlugins1 EXCLUDE_FROM_ALL SHARED plugins1.cpp)
target_include_directories(${PROJECT_NAME}_TestPlugins1
  PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins1)

add_library(${PROJECT_NAME}_TestPlugins2 EXCLUDE_FROM_ALL SHARED plugins2.cpp)
target_include_directories(${PROJECT_NAME}_TestPlugins2
  PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME}_TestPlugins2 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins2)

ament_add_gtest(${PROJECT_NAME}_utest utest.cpp)
if(TARGET ${PROJECT_NAME}_utest)
  target_include_directories(${PROJECT_NAME}_utest
    PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME}_utest ${PROJECT_NAME} ${Poco_LIBRARIES})
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_utest pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_utest ${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME}_TestPlugins2)
endif()

add_subdirectory(fviz_case_study)

=== test/fviz_case_study/CMakeLists.txt ===
add_library(${PROJECT_NAME}_Test_Fviz EXCLUDE_FROM_ALL SHARED fviz.cpp)
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME}_Test_Fviz PRIVATE "FVIZ_BUILDING_DLL")
endif()

# This "fviz_main" is just for testing locally, for the test see "fviz_test" below.
add_executable(${PROJECT_NAME}_Test_Fviz_Main EXCLUDE_FROM_ALL fviz_main.cpp)
target_include_directories(${PROJECT_NAME}_Test_Fviz_Main
  PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME}_Test_Fviz_Main
  ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)

add_library(${PROJECT_NAME}_Test_FvizDefaultPlugin
  EXCLUDE_FROM_ALL SHARED fviz_default_plugin.cpp)
target_include_directories(${PROJECT_NAME}_Test_FvizDefaultPlugin
  PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME}_Test_FvizDefaultPlugin
  ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)
class_loader_hide_library_symbols(${PROJECT_NAME}_Test_FvizDefaultPlugin)

ament_add_gtest(${PROJECT_NAME}_fviz_test fviz_test.cpp)
if(TARGET ${PROJECT_NAME}_fviz_test)
  target_include_directories(${PROJECT_NAME}_fviz_test
    PUBLIC "../include" ${console_bridge_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME}_fviz_test
    ${PROJECT_NAME} ${Poco_LIBRARIES} ${PROJECT_NAME}_Test_Fviz)
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_fviz_test pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_fviz_test
    ${PROJECT_NAME}_Test_FvizDefaultPlugin ${PROJECT_NAME}_Test_Fviz_Main)
endif()

=== debian/changelog ===
ros-r2b2-class-loader (1.0.0-8xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Esteve Fernandez <esteve@osrfoundation.org>  Sat, 01 Jul 2017 05:17:50 -0000

ros-r2b2-class-loader (0.3.2-8xenial) xenial; urgency=high

  * Fixed wrong handling of false statement (pkg-config was not installed)
  * Make catkin optional again
  * Contributors: Esteve Fernandez, Janosch Machowinski, Matthias Goldhoorn

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 22 Apr 2015 04:00:00 -0000

ros-r2b2-class-loader (0.3.1-8xenial) xenial; urgency=high

  * Depend on boost
  * Use FindPoco.cmake from ros/cmake_modules
  * Honor BUILD_SHARED_LIBS and do not force building shared libraries.
  * Contributors: Esteve Fernandez, Gary Servin, Scott K Logan

 -- Esteve Fernandez <esteve@osrfoundation.org>  Tue, 23 Dec 2014 05:00:00 -0000

ros-r2b2-class-loader (0.3.0-8xenial) xenial; urgency=high

  * Use system-provided console-bridge
  * Contributors: Esteve Fernandez

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 25 Jun 2014 04:00:00 -0000

ros-r2b2-class-loader (0.2.5-8xenial) xenial; urgency=high

  * Changed format of debug messages so that rosconsole_bridge can correctly parse the prefix
  * Improved debug output

 -- Esteve Fernandez <esteve@osrfoundation.org>  Tue, 04 Mar 2014 05:00:00 -0000

ros-r2b2-class-loader (0.2.4-8xenial) xenial; urgency=high

  * fix race condition with multi threaded library loading (#16 <https://github.com/ros/class_loader/issues/16>)

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 12 Feb 2014 05:00:00 -0000

ros-r2b2-class-loader (0.2.3-8xenial) xenial; urgency=high

  * fix missing class name in logWarn output

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 21 Aug 2013 04:00:00 -0000

ros-r2b2-class-loader (0.2.2-8xenial) xenial; urgency=high

  * check for CATKIN_ENABLE_TESTING (#10 <https://github.com/ros/class_loader/issues/10>)
  * fix find Poco to return full lib path (#8 <https://github.com/ros/class_loader/issues/8>)
  * add missing runtime destination for library under Windows
  * add Boosst component system

 -- Esteve Fernandez <esteve@osrfoundation.org>  Sun, 14 Jul 2013 04:00:00 -0000

ros-r2b2-class-loader (0.2.1-8xenial) xenial; urgency=high

  * improve check for Poco foundation and headers (#7 <https://github.com/ros/class_loader/issues/7>)

 -- Esteve Fernandez <esteve@osrfoundation.org>  Thu, 06 Jun 2013 04:00:00 -0000

ros-r2b2-class-loader (0.2.0-8xenial) xenial; urgency=high

  * use find_package for Poco/dl instead to make it work on other platforms
  * update Poco cmake file to include libdl on non-windows systems
  * No longer CATKIN_DEPEND on console_bridge

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 13 Mar 2013 04:00:00 -0000

ros-r2b2-class-loader (0.1.27-8xenial) xenial; urgency=high

  * change warning message for managed/unmanaged instance mixture in lazy loading mode

 -- Esteve Fernandez <esteve@osrfoundation.org>  Fri, 25 Jan 2013 05:00:00 -0000

ros-r2b2-class-loader (0.1.26-8xenial) xenial; urgency=high

  * fix all instances marked as unmanaged

 -- Esteve Fernandez <esteve@osrfoundation.org>  Thu, 17 Jan 2013 05:00:00 -0000

ros-r2b2-class-loader (0.1.25-8xenial) xenial; urgency=high

  * fix redundant destructor definition being pulled into plugin library for metaobjects instead of being contained with libclass_loader.so

 -- Esteve Fernandez <esteve@osrfoundation.org>  Wed, 16 Jan 2013 05:00:00 -0000

ros-r2b2-class-loader (0.1.24-8xenial) xenial; urgency=high

  * fix syntax error for logInform

 -- Esteve Fernandez <esteve@osrfoundation.org>  Mon, 14 Jan 2013 20:27:00 -0000

ros-r2b2-class-loader (0.1.23-8xenial) xenial; urgency=high

  * downgrade some warning messages to be info/debug

 -- Esteve Fernandez <esteve@osrfoundation.org>  Mon, 14 Jan 2013 20:23:00 -0000

ros-r2b2-class-loader (0.1.22-8xenial) xenial; urgency=high

  * add safety checks for mixing of managed/unmanaged mixing as well as pointer equivalency check between graveyard and newly created metaobjects

 -- Esteve Fernandez <esteve@osrfoundation.org>  Mon, 14 Jan 2013 20:01:00 -0000

ros-r2b2-class-loader (0.1.21-8xenial) xenial; urgency=high

  * fix compile issue on OSX in dependent packages (#3 <https://github.com/ros/class_loader/issues/3>)
  * add more debug information

 -- Esteve Fernandez <esteve@osrfoundation.org>  Sun, 13 Jan 2013 05:00:00 -0000

ros-r2b2-class-loader (0.1.20-8xenial) xenial; urgency=high

  * first public release for Groovy

 -- Esteve Fernandez <esteve@osrfoundation.org>  Fri, 21 Dec 2012 21:04:00 -0000

=== debian/control ===
Source: ros-r2b2-class-loader
Section: misc
Priority: extra
Maintainer: Esteve Fernandez <esteve@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), libpoco-dev, ros-r2b2-ament-cmake, ros-r2b2-ament-cmake-gtest, ros-r2b2-console-bridge, ros-r2b2-poco-vendor, ros-r2b2-ros-workspace
Homepage: http://ros.org/wiki/class_loader
Standards-Version: 3.9.2

Package: ros-r2b2-class-loader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpoco-dev, ros-r2b2-console-bridge, ros-r2b2-poco-vendor, ros-r2b2-ros-workspace
Description: The class_loader package is a ROS-independent package for loading plugins during runtime and the foundation of the higher level ROS &quot;pluginlib&quot; library.
 class_loader utilizes the host operating system's runtime loader to open runtime libraries (e.g. .so/.dll files), introspect the library for exported plugin classes, and allows users to instantiate objects of these exported classes without the explicit declaration (i.e. header file) for those classes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/r2b2/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Build type specific exports if any.

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/r2b2" -DAMENT_PREFIX_PATH="/opt/ros/r2b2"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
		dh_shlibdeps -l$(CURDIR)/debian/ros-r2b2-class-loader//opt/ros/r2b2/lib/:$(CURDIR)/debian/ros-r2b2-class-loader//opt/ros/r2b2/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/:/opt/ros/r2b2/lib/:/opt/ros/r2b2/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/r2b2/setup.sh" ]; then . "/opt/ros/r2b2/setup.sh"; fi && \
	dh_auto_install
